require("tir/engine")

local home_page = Tir.view("home.xhtml")

local links = {
  delicious = "http://delicious.com/catwell",
  github = "https://github.com/catwell",
  imgup = "http://img.flashtux.org/",
  twitter = "http://twitter.com/",
  w3c_xhtml = "http://validator.w3.org/check?uri=http://catwell.info/",
  w3c_atom = "http://validator.w3.org/feed/check.cgi?url=http://catwell.info/feed/",
}

local searchstrings = {
  AUR = "http://aur.archlinux.org/packages.php?K=%s",
  DDG = "https://duckduckgo.com/?q=%s",
  Google = "http://google.fr/search?q=%s",
  tresor = "http://www.cnrtl.fr/definition/%s",
  YouTube = "http://www.youtube.com/results?search_query=%s",
}

local home = function(web, req)
  local tpl = { links = links, searchstrings = searchstrings, form = { field = "" } }
  repeat
    tpl.form = web:prompt(home_page(tpl))
    local bt = tpl.form.bt
    local field = tpl.form.field
    if bt then
      if bt == "go" then
        if string.match(field, "^https?://") then web:redirect(field)
        else web:redirect("http://" .. field) end
      else web:redirect(searchstrings[bt]:format(field)) end
    end
  until nil
end

Tir.start{ route = '/', main = home }
